//+------------------------------------------------------------------+
//|                                                     SB.mq4       |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, vaot"
#property link      "http://www.fxxx.com"

//----------------------- INCLUDES


//----------------------- EA PARAMETER


extern double Lots = 0.1;
extern double StopLoss = 20;
extern double TakeProfit = 100;
extern int NumberOfTries = 10;
extern int Slippage = 5;
extern int MaxPeriod = 25;
extern int MinPeriod = 24;
extern string  TicketComment  = "My SB" ;
extern bool UseHourTrade = false;
extern int StartHour = 0;
extern int EndHour = 24;
extern int MaxOpenTrade = 1;
extern int MagicNumber = 888811;


//----------------------- GLOBAL VARIABLE


 int     cnt,
         total       = 0,
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
       buyStopLoss   = 0,
       buyTakeProfit = 0,
       sellStopLoss   = 0,
       sellTakeProfit = 0;
       
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
 
   
return(0);
}


//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
    
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{    
   
   
   
        

         
//----------------------- TIME FILTER
   if (UseHourTrade)
   {
      if(!(Hour()>=StartHour && Hour()<=EndHour))
      {
         Comment("Non-Trading Hours!");
         return(0);
      }
      
      return(0);
   }

//----------------------- CHECK CHART NEED MORE THAN 100 BARS
   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);  
   }


//----------------------- SET VALUE FOR VARIABLE

   
   double va1 = iCustom(NULL,0,"SnakeBorders",MaxPeriod,MinPeriod,MODE_UPPER,0);
   double va2 = iCustom(NULL,0,"SnakeBorders",MaxPeriod,MinPeriod,MODE_LOWER,0);
   double va3 = iCustom(NULL,0,"SnakeBorders",MaxPeriod,MinPeriod,MODE_SIGNAL,0);
   
  if(StopLoss!=0)
   {
      buyStopLoss   = NormalizeDouble(Ask-StopLoss*Point,4);
      sellStopLoss   = NormalizeDouble(Bid+StopLoss*Point,4);
   }
   
   if(TakeProfit!=0)
   {
      buyTakeProfit = NormalizeDouble(Ask+TakeProfit*Point,4);
      sellTakeProfit = NormalizeDouble(Bid-TakeProfit*Point,4);
   }

//----------------------- ENTRY

total = subTotalTrade();

if (total < MaxOpenTrade && va1 == va3) 
{
for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,buyStopLoss,buyTakeProfit,TicketComment,MagicNumber,0,Green);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
      
   return(ticket);
 }   
if (total < MaxOpenTrade && va2 == va3) 
{
for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,sellStopLoss,sellTakeProfit,TicketComment,MagicNumber,0,Red);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
      
   return(ticket);
 }   

//----------------------- EXIT

if (total>0)
{
if(va1 > va3) 
 {
      for(c=0;c<NumberOfTries;c++)
               {
                  ticket=OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }       
         
         
      }




if(va2 < va3)
      {
         
        for(c=0;c<NumberOfTries;c++)
               {
                  ticket=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }    
         
      }
   

return(0);

}


return(0);

}
//----------------------- END PROGRAM


//----------------------- NUMBER OF ORDER BASE ON SYMBOL AND MAGICNUMBER FUNCTION

int subTotalTrade()
{
   int
      cnt, total = 0;
   

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber) total++;
   }
   return(total);
}